pannelWidth=300
heightBuffer=40
boxHeight=40
optionsHeight=30
labelHeight=30
widthBuffer=30
width=pannelWidth*3+2*widthBuffer+15
height=800

boxCol=Turbine.UI.Color(1,0.2,0.2,0.2)
spaceCol=Turbine.UI.Color(1,0,0,0)
bgCol=Turbine.UI.Color(1,0.1,0.1,0.1)

normalButtonCol=Turbine.UI.Color(1,0.1,0.1,0.8)
hoverButtonCol=Turbine.UI.Color(1,0.2,0.2,0.9)
clickButtonCol=Turbine.UI.Color(1,0,0,0.7)
greyButtonCol=Turbine.UI.Color(1,0.3,0.3,0.3)






--0x4111d221
--0x41101f5b
--0x410ee565
--0x410e04d3



Window=Turbine.UI.Lotro.Window()
Window:SetText("GroupFinder")
Window:SetSize(width,height)
Window:SetPosition(tonumber(data["m"]["1"]),tonumber(data["m"]["2"]))
Window:SetVisible(false)

Window.MouseUp=function()

	data["m"]["1"]=tostring(Window:GetLeft())
	data["m"]["2"]=tostring(Window:GetTop())
	Turbine.PluginData.Save(Turbine.DataScope.Character, "GroupFinder", data);

end

Window.KeyDown = function(sender,args)
	--print(args.Action)
	if args.Action==268435888 then
		Window:SetVisible(not Window:IsVisible())
		if Window:IsVisible() then
			show()
		end
	elseif args.Action==145 or args.Action==268435635 then
		Window:SetVisible(false)
	end
end

Window:SetWantsKeyEvents(true)



InspectWindow=Turbine.UI.Lotro.Window()
InspectWindow:SetText("Stats")
InspectWindow:SetSize(500,height)
InspectWindow:SetPosition(tonumber(data["s"]["1"]),tonumber(data["s"]["2"]))

InspectWindow.MouseUp=function()
	data["s"]["1"]=tostring(InspectWindow:GetLeft())
	data["s"]["2"]=tostring(InspectWindow:GetTop())
	Turbine.PluginData.Save(Turbine.DataScope.Character, "GroupFinder", data);

end


inspectText=Turbine.UI.Label()
inspectText:SetParent(InspectWindow)
inspectText:SetPosition(widthBuffer,heightBuffer)
inspectText:SetSize(500-2*widthBuffer,height-2*heightBuffer)
inspectText:SetFont(  Turbine.UI.Lotro.Font.TrajanPro20)


left=Turbine.UI.ListBox()
left:SetParent(Window)
left:SetPosition(widthBuffer,heightBuffer)
left:SetSize(pannelWidth-10,height-2*heightBuffer)
left:SetOrientation(Turbine.UI.Orientation.Vertical)
left:SetBackColor(bgCol)


setLSB=function()
	local c=0
	for i in pairs(openInstances) do
		c=c+1
	end
	leftSB:SetMaximum(c)
end

leftSB=Turbine.UI.Lotro.ScrollBar()
leftSB:SetParent(Window)
leftSB:SetPosition(pannelWidth+widthBuffer,heightBuffer)
leftSB:SetSize(10,height-2*heightBuffer)
leftSB:SetOrientation(Turbine.UI.Orientation.Vertical)
setLSB()
leftSBPos=leftSB:GetValue()

function leftSB.ValueChanged()
	leftSBPos=leftSB:GetValue()
	populateLeft()
end

populateLeft=function()
	selfStats()
	local addmsg="x pls, "..localPlayer:GetClass()..convertToHidden(player)
	left:ClearItems()
	local c=0
	for i in pairs(openInstances) do
		if (c >= leftSBPos and c-leftSBPos < 9) or (leftSB:GetMaximum()-leftSBPos < 9 and leftSB:GetMaximum()-c <= 9 ) then
			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-10,5)
			--box:SetText(openInstances[i]["message"])
			box:SetBackColor(boxCol)
			left:AddItem(box)


			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-10,boxHeight)
			box:SetText(string.gsub(openInstances[i]["message"],"<i></i>",""))
			box:SetBackColor(boxCol)
			left:AddItem(box)
			local options=Turbine.UI.ListBox()
			options:SetSize(pannelWidth-10,optionsHeight)
			options:SetOrientation(Turbine.UI.Orientation.Horizontal)
			options:SetBackColor(boxCol)
			local cross=Turbine.UI.Button()
			cross:SetSize(24,18)
			cross:SetBackground(0x410e04d3)
			cross:SetBlendMode(Turbine.UI.BlendMode.Overlay)	
			function cross.MouseClick()
				openInstances[i]=nil
				setLSB()
				populateLeft()
			end
			options:AddItem(cross)



			local box=Turbine.UI.Label()
			box:SetSize(6,18)
			--box:SetText(openInstances[i]["message"])
			--box:SetBackColor(boxCol)
			options:AddItem(box)

			local tickWindow=Turbine.UI.Window()
			options:AddItem(tickWindow)
			tickWindow:SetSize(24,18)

			local tick=Turbine.UI.Lotro.Quickslot();
			tick:SetParent(tickWindow);
			tick:SetSize(24,18);
			tick:SetPosition(0,0)
			--print(player["Class"])
			--print(numbersToClasses[tonumber(player["Class"])])
			--print(i)
			local alias="/tell "..i.." x pls, "..numbersToClasses[tonumber(player["Class"])].." <u></u>"..localPlayerName.."<u></u>"..ownStatsHidden
			tick:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,alias))
			tick.ShortcutData=alias; --save the alias text for later
			tick:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
			tick.DragDrop=function()
			    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
			    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
			    sc:SetData(tick.ShortcutData);
			    tick:SetShortcut(sc);
			end
			
			--options:AddItem(tick)

			tick.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
			tick.Backdrop:SetParent(tickWindow);
			tick.Backdrop:SetSize(24,18);
			tick.Backdrop:SetPosition(0,0)--left:GetLeft()+30,left:GetTop()+(c-leftSBPos+1)*(boxHeight+5)+(c-leftSBPos)*(optionsHeight+5));--yeah, I got lazy and hardcoded the left side ;)
			tick.Backdrop:SetZOrder(tick:GetZOrder()+1); -- force the icon to be displayed above the quickslot
			tick.Backdrop:SetBackColor(boxCol);
			tick.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the 			quickslot behind it
			tick.Icon=Turbine.UI.Control();
			tick.Icon:SetParent(tickWindow);
			tick.Icon:SetSize(24,18);
			tick.Icon:SetPosition(0,0)--left:GetLeft()+30,left:GetTop()+(c-leftSBPos+1)*(boxHeight+5)+(c-leftSBPos)*(optionsHeight+5));--yeah, I got lazy and hardcoded the left side ;)
			--print(c)
			--print(leftSBPos)
			tick.Icon:SetZOrder(tick:GetZOrder()+2); -- force the icon to be displayed above the quickslot
			tick.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the 			quickslot behind it			
			tick.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your 			window's background instead of being completely transparent and displaying the game UI display
			
			-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
			tick.Icon:SetBackground(0x410e04d8)			
			tickWindow:SetVisible(true)

			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-(10+6+48+100+12),18)
			--box:SetText(openInstances[i]["message"])
			--box:SetBackColor(boxCol)
			options:AddItem(box)


			

			local inspect=Turbine.UI.Button()
			inspect:SetSize(100,18)
			inspect:SetText("View Stats")
			inspect:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			if openInstances[i]["metaData"] ~= nil then
				inspect:SetBackColor(normalButtonCol)
	
				function inspect.MouseClick()
					viewStats(openInstances[i]["metaData"],i)
				end
				function inspect.MouseEnter()
					inspect:SetBackColor(hoverButtonCol)

				end
				function inspect.MouseDown()
					inspect:SetBackColor(clickButtonCol)

				end
				function inspect.MouseUp()
					inspect:SetBackColor(hoverButtonCol)

				end
				function inspect.MouseLeave()
					inspect:SetBackColor(normalButtonCol)

				end




			else
				inspect:SetBackColor(greyButtonCol)

			end
			options:AddItem(inspect)



			left:AddItem(options)

			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-10,5)
			--box:SetText(openInstances[i]["message"])
			box:SetBackColor(spaceCol)
			left:AddItem(box)
			


		end
		c=c+1
	end

			




end


middle=Turbine.UI.ListBox()
middle:SetParent(Window)
middle:SetPosition(widthBuffer+pannelWidth+20,heightBuffer)
middle:SetSize(pannelWidth-10,height-2*heightBuffer)
middle:SetOrientation(Turbine.UI.Orientation.Vertical)
middle:SetBackColor(bgCol)
questionOrder={"Instance Name","Tier","Current Size","Max Size","Roles","Additional Information","Share To"}
defaultMiddleQuestions={["Instance Name"]="",["Tier"]="1",["Current Size"]="1",["Max Size"]="6",["Roles"]={["Tank"]=true,["Support"]=true,["Healer"]=true,["DPS"]=true},["Additional Information"]="",["Share To"]="lff"}
middleQuestions=defaultMiddleQuestions

roleIcons={["Tank"]={0x4111d374,0x4111d220,0x4111d227},["Support"]={0x4111d375,0x4111d221,0x4111d225},["Healer"]={0x4111d376,0x4111d222,0x4111d226},["DPS"]={0x4111d377,0x4111d223,0x4111d228}}


populateMiddle=function()
	middle:ClearItems()
	for j=1,#questionOrder do
		local i=questionOrder[j]
		if i ~= "Roles" then
			--print(i)
			local box=Turbine.UI.Label()

			box:SetSize(pannelWidth-10,5)
			box:SetFont(  Turbine.UI.Lotro.Font.TrajanPro20)

			--box:SetText(i..":")
			box:SetBackColor(bgCol)
			middle:AddItem(box)

			local box=Turbine.UI.Label()

			box:SetSize(pannelWidth-10,labelHeight)
			box:SetFont(  Turbine.UI.Lotro.Font.TrajanPro20)

			box:SetText(i..":")
			box:SetBackColor(bgCol)
			middle:AddItem(box)
			if i == "Current Size" then
				groupSize =Turbine.UI.Lotro.TextBox()
				groupSize:SetSize(pannelWidth-10,labelHeight)
				groupSize:SetText(middleQuestions[i])
				groupSize.TextChanged=function()
					middleQuestions[i]=groupSize:GetText()
				end
				middle:AddItem(groupSize)

			else
				local answer =Turbine.UI.Lotro.TextBox()
				answer:SetSize(pannelWidth-10,labelHeight)
				answer:SetText(middleQuestions[i])
				answer.TextChanged=function()
					middleQuestions[i]=answer:GetText()
				end
				middle:AddItem(answer)
			end
		else
			local box=Turbine.UI.Label()

			box:SetSize(pannelWidth-10,5)
			box:SetFont(  Turbine.UI.Lotro.Font.TrajanPro20)

			--box:SetText(i..":")
			box:SetBackColor(bgCol)
			middle:AddItem(box)

			local box=Turbine.UI.Label()

			box:SetSize(pannelWidth-10,labelHeight)
			box:SetFont(  Turbine.UI.Lotro.Font.TrajanPro20)

			box:SetText(i..":")
			box:SetBackColor(bgCol)
			middle:AddItem(box)

			local roleOptions=Turbine.UI.ListBox()
			roleOptions:SetSize(pannelWidth-10,40)
			roleOptions:SetOrientation(Turbine.UI.Orientation.Horizontal)
			local box=Turbine.UI.Label()
			box:SetSize((pannelWidth-10-160)/2,40)
			box:SetBackColor(bgCol)
			roleOptions:AddItem(box)
			
			for k in pairs(roleIcons) do
				--print(k)
				local icon=Turbine.UI.Button()
				icon:SetSize(40,40)
				icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				icon:SetBackground(roleIcons[k][1])
				icon.MouseEnter=function()
					icon:SetBackground(roleIcons[k][2])
				end
				icon.MouseClick=function()
					if middleQuestions["Roles"][k]==true then
						icon:SetBackground(roleIcons[k][3])
						middleQuestions["Roles"][k]=false
					else
						icon:SetBackground(roleIcons[k][1])
						middleQuestions["Roles"][k]=true

					end
				end
				icon.MouseLeave=function()
					if middleQuestions["Roles"][k]==true then
						icon:SetBackground(roleIcons[k][1])
					else
						icon:SetBackground(roleIcons[k][3])

					end
				end
				roleOptions:AddItem(icon)


			end

			middle:AddItem(roleOptions)
		end

	end

			local box=Turbine.UI.Label()

			box:SetSize(pannelWidth-10,10)
			box:SetFont(  Turbine.UI.Lotro.Font.TrajanPro20)

			--box:SetText(i..":")
			box:SetBackColor(bgCol)
			middle:AddItem(box)


			local shareWindow=Turbine.UI.Window()
			middle:AddItem(shareWindow)
			shareWindow:SetSize(pannelWidth-10,40)

			local share=Turbine.UI.Lotro.Quickslot();
			share:SetParent(shareWindow);
			share:SetSize(80,40);
			share:SetPosition((pannelWidth-10-80)/2,0)
			--print(player["Class"])
			--print(numbersToClasses[tonumber(player["Class"])])
			--print(i)
			local alias=""
			share:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,alias))
			share.ShortcutData=alias; --save the alias text for later
			share:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
			share.DragDrop=function()
			    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
			    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
			    sc:SetData(share.ShortcutData);
			    share:SetShortcut(sc);
			end
			
			--options:AddItem(share)

			share.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
			share.Backdrop:SetParent(shareWindow);
			share.Backdrop:SetSize(80,40);
			share.Backdrop:SetPosition((pannelWidth-10-80)/2,0)--left:GetLeft()+30,left:GetTop()+(c-leftSBPos+1)*(boxHeight+5)+(c-leftSBPos)*(optionsHeight+5));--yeah, I got lazy and hardcoded the left side ;)
			share.Backdrop:SetZOrder(share:GetZOrder()+1); -- force the icon to be displayed above the quickslot
			share.Backdrop:SetBackColor(boxCol);
			share.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the 			quickslot behind it
			share.Icon=Turbine.UI.Control();
			share.Icon:SetParent(shareWindow);
			share.Icon:SetSize(80,40);
			share.Icon:SetPosition((pannelWidth-10-80)/2,0)--left:GetLeft()+30,left:GetTop()+(c-leftSBPos+1)*(boxHeight+5)+(c-leftSBPos)*(optionsHeight+5));--yeah, I got lazy and hardcoded the left side ;)
			--print(c)
			--print(leftSBPos)
			share.Icon:SetZOrder(share:GetZOrder()+2); -- force the icon to be displayed above the quickslot
			share.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the 			quickslot behind it			
			share.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your 			window's background instead of being completely transparent and displaying the game UI display
			
			-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
			share.Icon:SetBackground(("GroupFinder/shareButton.tga"))
			share.MouseEnter=function()
				share.Icon:SetBackground(("GroupFinder/shareButtonHover.tga"))
				local specified=false
				local current=nil
				local needText="need"
				if middleQuestions["Current Size"]~=middleQuestions["Max Size"] then
				for i in pairs(middleQuestions["Roles"]) do
					if current == not middleQuestions["Roles"][i] then
						specified=true
					end
					if middleQuestions["Roles"][i] ==true then
						needText=needText.." "..i
					end
					current=middleQuestions["Roles"][i]
				end
				alias="/"..middleQuestions["Share To"].." "..middleQuestions["Instance Name"].." T"..middleQuestions["Tier"].." "..middleQuestions["Current Size"].."/"..middleQuestions["Max Size"].." "

				if specified then
					alias=alias..needText
				end
				alias=alias.." "..middleQuestions["Additional Information"]..ownStatsHidden
				else
				alias="/"..middleQuestions["Share To"].." "..middleQuestions["Instance Name"].." T"..middleQuestions["Tier"].." full thanks"
				end
				share:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,alias))
				share.ShortcutData=alias; --save the alias text for later

			end	
			share.MouseLeave=function()
				share.Icon:SetBackground(("GroupFinder/shareButton.tga"))	
			end
			share.MouseDown=function()
				share.Icon:SetBackground(("GroupFinder/shareButtonClick.tga"))	
			end
			share.MouseUp=function()
				share.Icon:SetBackground(("GroupFinder/shareButtonHover.tga"))	
			end


			shareWindow:SetVisible(true)

end


populateMiddle()



right=Turbine.UI.ListBox()
right:SetParent(Window)
right:SetPosition(widthBuffer+pannelWidth*2+25,heightBuffer)
right:SetSize(pannelWidth-10,height-2*heightBuffer)
right:SetOrientation(Turbine.UI.Orientation.Vertical)
right:SetBackColor(bgCol)


setRSB=function()
	local c=0
	for i in pairs(openRequests) do
		c=c+1
	end
	rightSB:SetMaximum(c)
end

rightSB=Turbine.UI.Lotro.ScrollBar()
rightSB:SetParent(Window)
rightSB:SetPosition(pannelWidth*3+20+widthBuffer,heightBuffer)
rightSB:SetSize(10,height-2*heightBuffer)
rightSB:SetOrientation(Turbine.UI.Orientation.Vertical)
setRSB()
rightSBPos=rightSB:GetValue()

function rightSB.ValueChanged()
	rightSBPos=rightSB:GetValue()
	populateRight()
end

populateRight=function()
	selfStats()
	local addmsg="x pls, "..localPlayer:GetClass()..convertToHidden(player)
	right:ClearItems()
	local c=0
	for i in pairs(openRequests) do
		if (c >= rightSBPos and c-rightSBPos < 9) or (rightSB:GetMaximum()-rightSBPos < 9 and rightSB:GetMaximum()-c <= 9 ) then
			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-10,5)
			--box:SetText(openRequests[i]["message"])
			box:SetBackColor(boxCol)
			right:AddItem(box)


			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-10,boxHeight)
			box:SetText(string.gsub(string.gsub(i..": "..openRequests[i]["message"],"<i></i>.+<i></i>",""),"<u></u>.+<u></u>",""))
			box:SetBackColor(boxCol)
			right:AddItem(box)
			local options=Turbine.UI.ListBox()
			options:SetSize(pannelWidth-10,optionsHeight)
			options:SetOrientation(Turbine.UI.Orientation.Horizontal)
			options:SetBackColor(boxCol)
			local cross=Turbine.UI.Button()
			cross:SetSize(24,18)
			cross:SetBackground(0x410e04d3)
			cross:SetBlendMode(Turbine.UI.BlendMode.Overlay)	
			function cross.MouseClick()
				openRequests[i]=nil
				setRSB()
				populateRight()
			end
			options:AddItem(cross)



			local box=Turbine.UI.Label()
			box:SetSize(6,18)
			--box:SetText(openRequests[i]["message"])
			--box:SetBackColor(boxCol)
			options:AddItem(box)

			local tickWindow=Turbine.UI.Window()
			options:AddItem(tickWindow)
			tickWindow:SetSize(24,18)

			local tick=Turbine.UI.Lotro.Quickslot();
			tick:SetParent(tickWindow);
			tick:SetSize(24,18);
			tick:SetPosition(0,0)
			--print(player["Class"])
			--print(numbersToClasses[tonumber(player["Class"])])
			--print(i)
			local alias="/invite "..i
			tick:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,alias))
			tick.ShortcutData=alias; --save the alias text for later
			tick:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
			tick.DragDrop=function()
			    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
			    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
			    sc:SetData(tick.ShortcutData);
			    tick:SetShortcut(sc);
			end
			
			--options:AddItem(tick)

			tick.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
			tick.Backdrop:SetParent(tickWindow);
			tick.Backdrop:SetSize(24,18);
			tick.Backdrop:SetPosition(0,0)--right:Getright()+30,right:GetTop()+(c-rightSBPos+1)*(boxHeight+5)+(c-rightSBPos)*(optionsHeight+5));--yeah, I got lazy and hardcoded the right side ;)
			tick.Backdrop:SetZOrder(tick:GetZOrder()+1); -- force the icon to be displayed above the quickslot
			tick.Backdrop:SetBackColor(boxCol);
			tick.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the 			quickslot behind it
			tick.Icon=Turbine.UI.Control();
			tick.Icon:SetParent(tickWindow);
			tick.Icon:SetSize(24,18);
			tick.Icon:SetPosition(0,0)--right:Getright()+30,right:GetTop()+(c-rightSBPos+1)*(boxHeight+5)+(c-rightSBPos)*(optionsHeight+5));--yeah, I got lazy and hardcoded the right side ;)
			--print(c)
			--print(rightSBPos)
			tick.Icon:SetZOrder(tick:GetZOrder()+2); -- force the icon to be displayed above the quickslot
			tick.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the 			quickslot behind it			
			tick.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your 			window's background instead of being completely transparent and displaying the game UI display
			
			-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
			tick.Icon:SetBackground(0x410e04d8)			
			tickWindow:SetVisible(true)

			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-(10+6+48+100+12),18)
			--box:SetText(openRequests[i]["message"])
			--box:SetBackColor(boxCol)
			options:AddItem(box)


			

			local inspect=Turbine.UI.Button()
			inspect:SetSize(100,18)
			inspect:SetText("View Stats")
			inspect:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			if openRequests[i]["metaData"] ~= nil then
				inspect:SetBackColor(normalButtonCol)
	
				function inspect.MouseClick()
					viewStats(openRequests[i]["metaData"],i)
				end
				function inspect.MouseEnter()
					inspect:SetBackColor(hoverButtonCol)

				end
				function inspect.MouseDown()
					inspect:SetBackColor(clickButtonCol)

				end
				function inspect.MouseUp()
					inspect:SetBackColor(hoverButtonCol)

				end
				function inspect.MouseLeave()
					inspect:SetBackColor(normalButtonCol)

				end




			else
				inspect:SetBackColor(greyButtonCol)

			end
			options:AddItem(inspect)



			right:AddItem(options)

			local box=Turbine.UI.Label()
			box:SetSize(pannelWidth-10,5)
			--box:SetText(openRequests[i]["message"])
			box:SetBackColor(spaceCol)
			right:AddItem(box)
			


		end
		c=c+1
	end

			




end


show=function()
	selfStats()
	ownStatsHidden=convertToHidden(player)
	local t=Turbine.Engine.GetLocalTime()
	for i in pairs(openInstances) do
		if t-openInstances[i]["time"]>deletionTime then
			openInstances[i]=nil
		end
	end
	for i in pairs(openRequests) do
		if t-openRequests[i]["time"]>deletionTime then
			openRequests[i]=nil
		end
	end

	populateLeft()
	populateRight()
	Window:SetVisible(true)

end
dc=Turbine.ShellCommand();
Turbine.Shell.AddCommand("gf", dc);
function dc:Execute(cmd, args)
 	show();
	Window:SetVisible(true)
end




